import junit.framework.TestCase;

/**
 * A JUnit test case class.
 * Every method starting with the word "test" will be called when running
 * the test with JUnit.
 */
public class TestSackOfFunctions extends TestCase {
  
  private double epsilon = 0.1;
  
  private boolean epsilonEquals(double a, double b){
    if( Math.abs(a-b) > epsilon ) return false;
    return true;
  }
  
  /**
   * A test method.
   * (Replace "X" with a name describing the test.  You may write as
   * many "testSomething" methods in this class as you wish, and each
   * one will be called when running JUnit over this class.)
   */
  public void testTwice() {
    if( !epsilonEquals(SackOfFunctions.twice(3.0),6.0 ) )fail();
  }
  
  public void testSquare() {
    if( !epsilonEquals(SackOfFunctions.square(3.0),9.0 ) ) fail("testSquare(): 3^2 == 9)");
    if( !epsilonEquals(SackOfFunctions.square(1.0),1.0 ) )fail("testSquare(): 1^2 == 1)");
    if( !epsilonEquals(SackOfFunctions.square(-12.0),144.0 ) )fail("testSquare(): (-12)^2 == 144)");
  }
  
  public void testCalcBMI() {
    double aBMI = SackOfFunctions.calcBMI(250,76);
    if( !epsilonEquals(aBMI,30.43 ) )
      fail("calcBMI(250,76) returned " + aBMI + ", but should return 30.43");
    aBMI =SackOfFunctions.calcBMI(155,71);
    if( !epsilonEquals(aBMI,21.62 ) )
      fail("calcBMI(155,71) returned " + aBMI + ", but should return 21.62");
  }
   
  //tests generated from https://www.chemicool.com/cgi-bin/gaslaws.pl
  // R from https://chem.libretexts.org/Core/Physical_and_Theoretical_Chemistry/Physical_Properties_of_Matter/States_of_Matter/Properties_of_Gases/Gas_Laws/The_Ideal_Gas_Law
  public void testIdealGasVolume(){
    double P,V,Vgt,n,T;
    P=2;
    n=1;
    T=293;
    V = SackOfFunctions.idealGasVolume(P, n, T);
    Vgt = 12.0207352578337;
    if( !epsilonEquals(V,Vgt ) )
      fail("idealGasVolumelcBMI(2,1,293) returned " + V + ", but should return "+Vgt);
    P=0.5;
    n=11;
    T=493;
    V = SackOfFunctions.idealGasVolume(P, n, T);
    Vgt = 889.944673081668;
    if( !epsilonEquals(V,Vgt ) )
      fail("idealGasVolumelcBMI(0.5,11,493) returned " + V + ", but should return "+Vgt);
  }
  
  public void testHypotenuseLength(){
    double a,b,c,cGT;
    a=2;
    b=3;
    c=SackOfFunctions.hypotenuseLength(a,b);
    cGT=3.61;
    if( !epsilonEquals(c,cGT ) )
      fail("On a=" + a+" ,b="+b+"your hyptenuseLength returned "+c+"but "+cGT+"was expected.");
    a=4;
    b=2;
    c=SackOfFunctions.hypotenuseLength(a,b);
    cGT=4.47;
    if( !epsilonEquals(c,cGT ) )
      fail("On a=" + a+" ,b="+b+"your hyptenuseLength returned "+c+"but "+cGT+"was expected.");
    
  }
  
  
}
